;       Table include file for original board




forcebd:
	ret	; do nothing unless 4 player board







chk_usbps2:

	mov	A,0F3h	; set port 1 to open drain
	iowr	GPIO_CONFIG_REG
	mov	A,jp1_bit
	iowr	auto_port
	DELAY	5
	
	iord	auto_port			; jp1 jumper?
	cpl
	and	A,jp1_bit
	jz	chk2
	SETBIT	jp1, ksc_flags
chk2:
	
	
	mov        A,NORMAL                        ;configure GPIO reg back again
    iowr     GPIO_CONFIG_REG
    mov	A,ffh
    iowr	auto_port
	ret


ksc_scan_keys:
	mov	X,ksc_db_keys	; set X to start of count table
	iord	Port0_Data	; read port	
	call	ksc_chbyte
			
	iord	Port1_Data	; read port	
	or	A,(auto_bit + jp1_bit)	; take out auto bit
	call	ksc_chbyte
		
	iord	Port2_Data
	call	ksc_chbyte
	
	CHKFLAG	ps2_active_flagC	; if aux active don't check port 3
	jnz	scan1
	mov	A, [ksc_p3out]
	or	A,(NUM_LOCK_LED | CAPS_LOCK_LED | SCROLL_LOCK_LED)
	iowr	Port3_Data	; blank the leds
	nop
	nop
	iord	Port3_Data
	or	A,auxclk_bit	; take out aux kbd bits
	or	A,auxdata_bit
	push	A
	mov 	A,[ksc_p3out]	; write the leds again
	iowr	Port3_Data
	pop	A
	call	ksc_chbyte
scan1:
	ret





	XPAGEOFF
	

ksc_shiftkey:
	DB	11h	; key number of shift key	


;========================================================================
;  KEY TABLE WITH MAME JUMPER, NO SHIFT

ksc_table_auto:
	DB	0F5H	;1 UP		UP			PORT0 BIT0	0
	DB	0F4H	;1 RIGHT	RIGHT		PORT0 BIT1	1
	DB	14H	;1 BT 1		L-CTRL		PORT0 BIT2	2
	DB	0EBH	;1 LEFT		LEFT		PORT0 BIT3	3
	DB	29H	;1 BT 3		SPACE		PORT0 BIT4	4
	DB	0F2H	;1 DOWN		DOWN		PORT0 BIT5	5
	DB	1AH	;1 BT 5		Z			PORT0 BIT6	6
	DB	11H	;1 BT 2		ALT			PORT0 BIT7	7
	DB	34H	;2 RIGHT	G			PORT1 BIT0	8
	DB	12H	;1 BT 4		L-SHIFT		PORT1 BIT1	9
	DB	23H	;2 LEFT		D			PORT1 BIT2	A
	DB	22H	;1 BT 6		X			PORT1 BIT3	B
	DB	2DH	;2 UP		R			PORT1 BIT4	C
	DB	00	;AUTO					PORT1 BIT5	D
	DB	2BH	;2 DOWN		F			PORT1 BIT6	E
	DB	00	;JP1					PORT1 BIT7	F
	DB	1CH	;2 BT 1		A			PORT2 BIT0	10
	DB	16H	;START 1	1			PORT2 BIT1	11
	DB	1BH	;2 BT 2		S			PORT2 BIT2	12
	DB	1EH	;START 2	2			PORT2 BIT3	13
	DB	15H	;2 BT 3		Q			PORT2 BIT4	14
	DB	2EH	;COIN 1		5			PORT2 BIT5	15
	DB	1DH	;2 BT 4		W			PORT2 BIT6	16
	DB	36H	;COIN 2		6			PORT2 BIT7	17
	DB	43H	;2 BT 5		I			PORT3 BIT0	18
	DB	21H	;1 BT 7		C			PORT3 BIT1	19
	DB	42H	;2 BT 6		K			PORT3 BIT2	1A
	DB	2AH	;1 BT 8		V			PORT3 BIT3	1B
	DB	3BH	;2 BT 7		J			PORT3 BIT4	1C
	DB	00	;AUXCLK					PORT3 BIT5	1D
	DB	00	;AUXDATA				PORT3 BIT6	1E
	DB	4BH	;2 BT 8		L			PORT3 BIT7	1F
	
                    
	
;=============================================================================
;  KEY TABLE WITH MAME JUMPER AND SHIFT

ksc_table_auto_shift:
	DB	0EH	;1 UP		TILDE		PORT0 BIT0
	DB	0DH	;1 RIGHT	TAB			PORT0 BIT1
	DB	2EH	;1 BT 1		5	  		PORT0 BIT2
	DB	5AH	;1 LEFT		ENTER		PORT0 BIT3
	DB	00	;1 BT 3		     		PORT0 BIT4
	DB	4DH	;1 DOWN		P   		PORT0 BIT5
	DB	00	;1 BT 5					PORT0 BIT6
	DB	00	;1 BT 2		   			PORT0 BIT7
	DB	00	;2 RIGHT	 			PORT1 BIT0
	DB	00	;1 BT 4		       		PORT1 BIT1
	DB	00	;2 LEFT		 			PORT1 BIT2
	DB	00	;1 BT 6					PORT1 BIT3
	DB	00	;2 UP		 			PORT1 BIT4
	DB	00	;AUTO			 		PORT1 BIT5
	DB	00	;2 DOWN		 			PORT1 BIT6
	DB	00	;JP1					PORT1 BIT7
	DB	00	;2 BT 1		 			PORT2 BIT0
	DB	16H	;START 1	 			PORT2 BIT1
	DB	00	;2 BT 2		 			PORT2 BIT2
	DB	76H	;START 2	ESC			PORT2 BIT3
	DB	00	;2 BT 3		 			PORT2 BIT4
	DB	00	;COIN 1		 			PORT2 BIT5
	DB	00	;2 BT 4		 			PORT2 BIT6
	DB	00	;COIN 2		 			PORT2 BIT7
	DB	00	;2 BT 5					PORT3 BIT0
	DB	00	;1 BT 7					PORT3 BIT1
	DB	00	;2 BT 6					PORT3 BIT2
	DB	00	;1 BT 8					PORT3 BIT3
	DB	00	;2 BT 7					PORT3 BIT4
	DB	00	;AUXCLK					PORT3 BIT5
	DB	00	;AUXDATA				PORT3 BIT6
	DB	35h	;2 BT 8		Y(for prog)	PORT3 BIT7
	
	
	
;========================================================================
;  KEY TABLE WITH TEST

ksc_table_test:
	DB	75H	;1 UP		PAD 8		PORT0 BIT0	0
	DB	74H	;1 RIGHT	PAD 6		PORT0 BIT1	1
	DB	73H	;1 BT 1		PAD 5		PORT0 BIT2	2
	DB	6BH	;1 LEFT		PAD 4		PORT0 BIT3	3
	DB	7AH	;1 BT 3		PAD 3		PORT0 BIT4	4
	DB	72H	;1 DOWN		PAD 2		PORT0 BIT5	5
	DB	7DH	;1 BT 5		PAD 9		PORT0 BIT6	6
	DB	69H	;1 BT 2		PAD 1		PORT0 BIT7	7
	DB	3AH	;2 RIGHT	M			PORT1 BIT0	8
	DB	6CH	;1 BT 4		PAD 7		PORT1 BIT1	9
	DB	33H	;2 LEFT		H			PORT1 BIT2	A
	DB	70H	;1 BT 6		PAD 0		PORT1 BIT3	B
	DB	32H	;2 UP		B			PORT1 BIT4	C
	DB	00	;AUTO					PORT1 BIT5	D
	DB	24H	;2 DOWN		E			PORT1 BIT6	E
	DB	00	;JP1					PORT1 BIT7	F
	DB	1DH	;2 BT 1		W			PORT2 BIT0	10
	DB	41H	;START 1	,			PORT2 BIT1	11
	DB	44H	;2 BT 2		O			PORT2 BIT2	12
	DB	52H	;START 2	'			PORT2 BIT3	13
	DB	3CH	;2 BT 3		U			PORT2 BIT4	14
	DB	00H	;COIN 1					PORT2 BIT5	15
	DB	35H	;2 BT 4		Y			PORT2 BIT6	16
	DB	49H	;COIN 2		.			PORT2 BIT7	17
	DB	4EH	;2 BT 5		-			PORT3 BIT0	18
	DB	79H	;1 BT 7		PAD +		PORT3 BIT1	19
	DB	55H	;2 BT 6		=			PORT3 BIT2	1A
	DB	7BH	;1 BT 8		PAD -		PORT3 BIT3	1B
	DB	54H	;2 BT 7		[			PORT3 BIT4	1C
	DB	00	;AUXCLK					PORT3 BIT5	1D
	DB	00	;AUXDATA				PORT3 BIT6	1E
	DB	5BH	;2 BT 8		]			PORT3 BIT7	1F

   

	XPAGEON
	
	
 NOP
 XPAGEOFF

	


;=============  map EEPROM contents to RAM contents ================
; indexed with A = position in EEPROM. This is address of code as sent by IPACUTIL
; returns with A = position in RAM. address of code used in look-up.
romramtbl:

db 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30


db 31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67


XPAGEON



;table to translate ps2-command enumeration of leds into our own bits
XPAGEOFF
ps2_led_tbl:
    db  0
    db  SCROLL_LOCK_LED
    db  NUM_LOCK_LED
    db  SCROLL_LOCK_LED + NUM_LOCK_LED
    db  CAPS_LOCK_LED
    db  CAPS_LOCK_LED + SCROLL_LOCK_LED
    db  CAPS_LOCK_LED + NUM_LOCK_LED
    db  CAPS_LOCK_LED + NUM_LOCK_LED + SCROLL_LOCK_LED       
XPAGEON