/*************************************************************************
 * TLV 02/14/2002                                                        *
 * Copyright (C) 2002 Travis Veldkamp                                    *
 *                                                                       *
 * This is free software; you can redistribute it and/or modify          *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation; either version 2 of the License, or     *
 * at your option) any later version.                                    *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * You should have received a copy of the GNU General Public License     *
 * along with Foobar; if not, write to:                                  *
 *                   Free Software Foundation, Inc.                      *
 *                   59 Temple Place                                     *
 *                   Suite 330                                           *
 *                   Boston, MA  02111-1307                              *
 *                   USA                                                 *
 *************************************************************************/

#include <linux/kd.h>
#include <linux/ioport.h>
#include <asm/io.h>

static const int LED_ON = 1;
static const int LED_OFF = 0;

static const int LED_SCRLCK = 0x01;
static const int LED_NUMLCK = 0x02;
static const int LED_CAPLCK = 0x04;

static const int LED_ALL_ON = 0x07;
static const int LED_ALL_OFF= 0x00;

/*Keyboard port info*/
static const int KBD_DATA_REG = 0x60;
static const int KBD_CNTL_REG = 0x64;



int SendLed(int console_fd, int code);

int CheckLed(int console_fd, int led);
